{ ************************************************************************ }
{ Ancestral Forms 1.1 Demonstration                                        }
{ (C) Sam Liddicott 1996                                                   }
{ ------------------------------------------------------------------------ }
{ This is a child form.  It can have further children.                     }
{ The only special requirements are:                                       }
{   * Uses ...,RootForm,Parent......;                                      }
{   * TChildForm=(TAncestorForm);                                          }
{ ************************************************************************ }
unit Child;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, parent, ExtCtrls;

type
  TChildForm = class(TAncestorForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Label2: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
  public
    Procedure Loaded; override;
  end;


var
  ChildForm: TChildForm;

implementation

{$R *.DFM}

{ Button2 only exists in the child }
procedure TChildForm.Button2Click(Sender: TObject);
begin
  Button1.Caption:='Hello Button 1';
  Panel1.Caption:='Hello Panel 1';
  Label1.Caption:='And Label1 ONLY exists in the ancestral form!';
end;

{ Override the event handler for Button1 in the ancestral form }
procedure TChildForm.Button1Click(Sender: TObject);
begin
  Panel1.Caption:='Descendant Button1 Click';
end;

{ This is to demonstrate the repeated calls the the forms own .loaded }
{ csLoading is always maintained in component state until after the }
{ last set of resources has loaded. }
{ I.E. After you call inherited .loaded, IF ClassLevel=0, then csLoading }
{ is no longer in ComponentState }
Procedure TChildForm.Loaded;
begin
  writeln(Classname,': ',CurrentClass.classname,' ',ClassLevel);
  Inherited Loaded;
end;

end.
